
/*
 *  ERROR.H
 *
 *    (c)Copyright 1992-1997 Obvious Implementations Corp.  Redistribution and
 *    use is allowed under the terms of the DICE-LICENSE FILE,
 *    DICE-LICENSE.TXT.
 */

#define EERROR	1
#define EWARN	2
#define EFATAL	3

#define EF_ERROR    (EERROR << 12)
#define EF_WARN     (EWARN << 12)
#define EF_FATAL    (EFATAL << 12)

#define EF_MASK     (0xF000)

#define EFATAL_INPUT_FILE_REQUIRED	(EF_FATAL|1)
#define EFATAL_CANT_CREATE_FILE 	(EF_FATAL|2)
#define EERROR_UNKNOWN_DIRECTIVE	(EF_ERROR|3)
#define EFATAL_MAX_IFS			(EF_FATAL|4)
#define EERROR_MULTIPLE_ELSE_FOR_IF	(EF_ERROR|6)
#define EERROR_ENDIF_WITHOUT_IF 	(EF_ERROR|7)
#define EERROR_ERROR_DIRECTIVE		(EF_ERROR|9)
#define EFATAL_MAX_INCLUDE		(EF_FATAL|10)
#define EERROR_FILE_SIZE		(EF_ERROR|11)
#define EFATAL_NO_MEMORY		(EF_FATAL|12)
#define EERROR_READ_ERROR		(EF_ERROR|13)
#define EFATAL_READ_ERROR		(EF_FATAL|13)
#define EERROR_STRINGTIZE		(EF_ERROR|14)
#define EWARN_IFS_LEFT_PENDING		( EF_WARN|15)
#define EERROR_UNEXPECTED_EOF		(EF_ERROR|16)
#define EFATAL_SOFTERROR_177		(EF_ERROR|17)
#define EERROR_UNTERMINATED_STRING	(EF_ERROR|18)
#define EERROR_UNTERMINATED_CHARCONST	(EF_ERROR|19)
#define EFATAL_READ_PRECOMP		(EF_FATAL|20)
#define EFATAL_PARSE_PRECOMP		(EF_FATAL|21)
#define EFATAL_SEEK_OUTPUT		(EF_FATAL|22)
#define EERROR_UNDEF_NO_SYMBOL		(EF_ERROR|23)
#define EERROR_ILLEGAL_NULL_SYMBOL	(EF_ERROR|24)
#define EFATAL_MAX_MACRO_ARGS		(EF_FATAL|25)
#define EERROR_EXPECTED_COMMA		(EF_ERROR|26)
#define EERROR_EXPECTED_CLOSE_PAREN	(EF_ERROR|27)
#define EFATAL_SOFT_ERROR_REPLACE	(EF_FATAL|28)
#define EERROR_RECURSIVE_MACRO		(EF_ERROR|29)
#define EERROR_UNEXPECTED_EOF_MACRO	(EF_ERROR|30)
#define EWARN_MACRO_CROSSES_INCLUDE	( EF_WARN|31)
#define EERROR_NOT_ENOUGH_ARGS_MACRO	(EF_ERROR|33)
#define EERROR_EXPECTED_CLOSE_PAREN_MAC (EF_ERROR|34)
#define EFATAL_SOFTWARE_ERROR_CREATOR	(EF_FATAL|35)
#define EFATAL_SOFTWARE_ERROR_MACRO	(EF_FATAL|36)
#define EFATAL_SOFTWARE_ERROR_ALLOCATE	(EF_FATAL|37)
#define EFATAL_NOMINAL_INCLUDE		(EF_FATAL|38)
#define EERROR_SYNTAX_ERROR		(EF_ERROR|39)
#define EERROR_TOO_MANY_CLOSE_PARENS	(EF_ERROR|40)
#define EERROR_EXPRESSION_TOO_COMPLEX	(EF_ERROR|41)
#define EFATAL_ERROR_PARSING_EXP	(EF_FATAL|42)
#define EERROR_PARSING_INCLUDE		(EF_ERROR|43)
#define EFATAL_SEEK_PRECOMP		(EF_ERROR|44)
#define EERROR_EXPECTED_COMMA_CLOSE	(EF_ERROR|45)
#define EERROR_EXPECTED_CLOSE_PAREN_ARG (EF_ERROR|46)
#define EERROR_CANT_OPEN_FILE		(EF_ERROR|47)
#define EWARN_NESTED_COMMENT		( EF_WARN|48)


